// Подключаем библиотеки:
#include <Wire.h>                            // подключаем библиотеку для работы с шиной I2C
#include <LCD_1602_RUS.h>                    // подключаем библиотеку для работы с LCD_Rus дисплеем
#include <Keypad.h>                          // подключаем библиотеку для работы с матричной клавиатурой
 
// Объявляем переменные и константы:
LCD_1602_RUS lcd1(0x27, 20, 4);               // объявляем переменную для работы с LCD дисплеем, указывая параметры дисплея (адрес I2C = 0x3F, количество столбцов = 20, количество строк = 4)

const byte ROWS = 4;                         // 4 строки
const byte COLS = 5;                         // 5 столбца
char keys[ROWS][COLS] = {
  {'1', '3', '9', 'A', 'G'},
  {'2', '4', '0', 'B', 'I'},
  {'5', '7', 'C', 'E', 'K'},
  {'6', '8', 'D', 'F', 'L'},
  };
byte rowPins[ROWS] = { A0, A1, A2, A3};
byte colPins[COLS] = { A5, A6, A7, A8, A9};
 
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

void setup() {
   Serial.begin(9600);
  Serial1.begin(9600);
  Serial2.begin(9600);
  
  lcd1.init();                                // инициируем LCD дисплей
  lcd1.backlight();                           // включаем подсветку LCD дисплея

 // выводим общие данные на дисплей
  lcd1.setCursor(0, 0);                       // устанавливаем курсор в позицию: столбец 0, строка 0
  lcd1.print( L"Станция");                    // выводим текст "Станция"
 
  
 // назначаем цифровые выходы
  for (int i =  2; i <= 19; i++) pinMode(i, OUTPUT);  // устанавливает режим работы порта - выход
 
  }

  void loop() { 
  char key = keypad.getKey(); 
  //char key = (char)Serial.read(); 
  Serial.println(key); 
// Управление станцией с левой стороны 
  if (key != 0) { 

// Управление станцией с левой стороны
  //if (key) {
    lcd1.setCursor(5, 1);                    // устанавливаем курсор в позицию: столбец 5, строка 1
 
    switch (key) {
      case '1':
        lcd1.print("1");                  // выводим -- на LCD дисплей
        digitalWrite(13, HIGH);          // "включаем" реле 1-1 путь
        delay(500) ;                     // ждем 500 mс
        digitalWrite(13, LOW);           // "выключаем" реле
        break;
 
      case '2':
        lcd1.print("2");                  // выводим -- на LCD дисплей
        Serial1.println('2')  ;          // "включаем" реле 1-2 путь
        break;
   
      case '3':
        lcd1.print(" ");                  // выводим -- на LCD дисплей
        Serial2.println('2')  ;          // "включаем" реле 1-2 путь
        break;    
        }
      }  
    }
